﻿Imports DLL

Public Class SearchHandler

    Public List As New List(Of String)

    Public ReadOnly Property PokemonFileLocation As String
        Get
            Return IO.Path.Combine(Application.StartupPath, "TextFiles")
        End Get
    End Property
    Public ReadOnly Property CustomPokemonFileLocation As String
        Get
            Return IO.Path.Combine(Application.StartupPath, "CustomTextFiles")
        End Get
    End Property

    Public Sub New()
        List.AddRange(IO.Directory.GetFiles(PokemonFileLocation, "*.txt"))
        List.AddRange(IO.Directory.GetFiles(CustomPokemonFileLocation, "*.txt"))
    End Sub

    Public Sub Refresh()
        SyncLock List
            List.Clear()
            List.AddRange(IO.Directory.GetFiles(PokemonFileLocation, "*.txt"))
            List.AddRange(IO.Directory.GetFiles(CustomPokemonFileLocation, "*.txt"))
        End SyncLock
    End Sub

    Public Function ReturnFilteredList(ByVal name As String) As String
        Dim Results As New List(Of String)
        Dim StrBld As New System.Text.StringBuilder
        SyncLock List
            For Each item As String In List
                If IO.File.Exists(item) Then
                    Dim PD As New PokemonInformation(item)
                    If PD.Name.Contains(name) Then StrBld.Append(String.Format("{0}|{1}|{2}|{3}|", PD.Name, PD.ID, PD.IP, PD.IName))
                End If
            Next
        End SyncLock
        Return StrBld.ToString.TrimEnd("|"c)
    End Function

    Public Function ReturnUnfilteredList() As String
        'Me.Refresh()
        Dim StrBld As New System.Text.StringBuilder
        SyncLock List
            For Each item As String In List
                If IO.File.Exists(item) Then
                    Dim PD As New PokemonInformation(item)
                    StrBld.Append(String.Format("{0}|{1}|{2}|{3}|", PD.Name, PD.ID, PD.IP, PD.IName))
                End If
            Next
        End SyncLock
        Return StrBld.ToString.TrimEnd("|"c)
    End Function

End Class