﻿Public Class MainForm
    Public WithEvents server As New ServerBackend(666)
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_start.Click
        server.Begin()
        btn_stop.Enabled = True
        btn_start.Enabled = False
    End Sub

    Private Delegate Sub d_LogMessage(ByVal msg As String)
    Private Sub LogMessage(ByVal msg As String)
        If lb_log.InvokeRequired Then
            lb_log.Invoke(New d_LogMessage(AddressOf LogMessage), msg)
        Else
            lb_log.Items.Add(msg)
            lb_log.SelectedIndex = lb_log.Items.Count - 1
        End If
    End Sub

    Private Delegate Sub d_CC(ByVal user As String, ByVal state As Boolean)
    Private Sub CC(ByVal user As String, ByVal state As Boolean)
        If ListBox1.InvokeRequired Then
            ListBox1.Invoke(New d_CC(AddressOf CC), user, state)
        Else
            Select Case state
                Case True
                    ListBox1.Items.Add(user)
                Case False
                    SyncLock ListBox1.Items
                        For i As Integer = ListBox1.Items.Count - 1 To 0 Step -1
                            If ListBox1.Items(i).ToString = user Then ListBox1.Items.RemoveAt(i)
                        Next
                    End SyncLock
            End Select
        End If
    End Sub

    Private Sub server_ChatChanged(ByVal user As String, ByVal state As Boolean) Handles server.ChatChanged
        Call CC(user, state)
    End Sub

    Private Sub server_Log(ByVal sender As Object, ByVal message As String) Handles server.Log
        LogMessage(String.Format("{0}: {1}", DateTime.Now.ToShortTimeString, message))
    End Sub

    Private Sub btn_stop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_stop.Click
        server.Dispose()
        btn_stop.Enabled = False
        btn_start.Enabled = True
    End Sub

    Private Sub btn_gen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_gen.Click
        server.GenerateTextFiles(Application.StartupPath)
    End Sub

    Private Sub MainForm_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        server.Dispose()
        Application.Exit()
    End Sub

    Private Sub MainForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        LogMessage("Welcome to the Global Distribution System Server!")
    End Sub

    Private Sub Button1_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        If ListBox1.SelectedIndex > -1 Then
            server.KickChat(ListBox1.SelectedItem.ToString)
        End If
    End Sub

    Private Sub btn_manage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_manage.Click
        Dim MF As New ManageForm
        MF.Reports = server.Reports
        MF.MyParent = Me
        MF.Show()
        server.Reports.Clear()
    End Sub
End Class