﻿Public Class ManageForm
    Public Property MyParent As MainForm
    Public Property Reports As List(Of DLL.ReportPokemon)

    Private Sub lb_reports_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lb_reports.SelectedIndexChanged
        GroupBox2.Enabled = lb_reports.SelectedIndex > -1

        If Not lb_reports.SelectedIndex = -1 Then
            'This is the ID so...yeah.
            Dim FP As String = New PokemonClass().ReturnFilePath(lb_reports.SelectedItem.ToString)
            Dim IP As String = New PokemonClass().ReturnUploaderIP(lb_reports.SelectedItem.ToString)
            'Have filepath, create info class and pokehack handler.
            'Dim PI As New PokemonInformation(FP)
            Dim Pkm As New PokeHack.Pokemon(IO.File.ReadAllBytes(FP))
            With Pkm

                'Normal data
                tb_pkm_name.Text = .Name
                tb_gender.Text = .Gender.ToString
                tb_ip.Text = IP
                tb_move1.Text = .Move1Str
                tb_move2.Text = .Move2Str
                tb_move3.Text = .Move3Str
                tb_move4.Text = .Move4Str
                tb_nickname.Text = Pkm.Nickname
                tb_origin.Text = .Origin.ToString
                tb_OTID.Text = .OriginalTrainer.ToString
                tb_otname.Text = .OTName
                tb_otsid.Text = .SecretID.ToString

                'IV data
                IV_atk.Value = .AttIV
                IV_def.Value = .DefIV
                IV_HP.Value = .HPIV
                IV_SA.Value = .SPAttIV
                IV_SD.Value = .SPDefIV
                IV_Speed.Value = .SpeIV

                'EV data
                EV_atk.Value = .AttEV
                EV_def.Value = .DefEV
                EV_HP.Value = .HPEV
                EV_SA.Value = .SPAttEV
                EV_SD.Value = .SPDefEV
                EV_Speed.Value = .SpeEV

                'CS data
                CS_atk.Value = .Attack
                CS_def.Value = .Defense
                CS_HP.Value = .HP
                CS_SA.Value = .SpecialAttack
                CS_SD.Value = .SpecialDefense
                CS_Speed.Value = .Speed

                cb_fateful.Checked = .IsFatefulEncounter
                cb_shiny.Checked = .IsShiny
                lbl_level.Text = String.Format("Level: {0}", .Level.ToString)

            End With
            tb_reported.Text = CType(lb_reports.SelectedItem, DLL.ReportPokemon).ReportedBy
        End If
    End Sub

    Private Sub btn_delete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_delete.Click
        'Get file info
        Dim FP As String = New PokemonClass().ReturnFilePath(lb_reports.SelectedItem.ToString)
        Dim TFP As String = New PokemonClass().ReturnTextPath(lb_reports.SelectedItem.ToString)
        'Info got, create a PI class
        'Dim PI As New PokemonInformation(FP)

        'IO.File.Delete(PI.Path)
        IO.File.Delete(FP)
        IO.File.Delete(TFP)

        MessageBox.Show("Pokemon deleted")
        lb_reports.Items.RemoveAt(lb_reports.SelectedIndex)
        lb_reports.SelectedIndex = -1
        MyParent.server.RefreshDirectory()

    End Sub

    Private Sub btn_dismiss_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_dismiss.Click
        lb_reports.Items.RemoveAt(lb_reports.SelectedIndex)
        lb_reports.SelectedIndex = -1
        MessageBox.Show("Report dismissed")
    End Sub

    Private Sub ManageForm_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        If lb_reports.Items.Count > 0 Then
            Select Case MessageBox.Show("You have some reports to look at still, are you sure you want to close the window? Any remaining reports will be dismissed.",
                                        "You sure?",
                                        MessageBoxButtons.YesNo, MessageBoxIcon.Question)
                Case Windows.Forms.DialogResult.Yes
                    e.Cancel = False
                Case Windows.Forms.DialogResult.No
                    e.Cancel = True
            End Select
        Else
            e.Cancel = False
        End If
    End Sub

    Private Sub ManageForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        For Each item As DLL.ReportPokemon In Reports
            lb_reports.Items.Add(item)
        Next
    End Sub

End Class